This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1029227 - Review Request: cvc4 - Automatic theorem prover for SMT problems
Review Request: cvc4 - Automatic theorem prover for SMT problems
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michel Alexandre Salim
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-11 17:49 EST by Jerry James
Modified: 2014-02-14 03:01 EST (History)
3 users (show)

See Also:
Fixed In Version: cvc4-1.3-3.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-14 03:01:16 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
michel: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jerry James 2013-11-11 17:49:37 EST
Spec URL: http://jjames.fedorapeople.org/cvc4/cvc4.spec
SRPM URL: http://jjames.fedorapeople.org/cvc4/cvc4-1.2-1.fc21.src.rpm
Fedora Account System Username: jjames
Description: 
CVC4 is an efficient open-source automatic theorem prover for satisfiability modulo theories (SMT) problems.  It can be used to prove the validity (or, dually, the satisfiability) of first-order formulas in a large number of built-in logical theories and their combination.

CVC4 is the fourth in the Cooperating Validity Checker family of tools (CVC, CVC Lite, CVC3) but does not directly incorporate code from any previous version.  A joint project of NYU and U Iowa, CVC4 aims to support the features of CVC3 and SMT-LIBv2 while optimizing the design of the core system architecture and decision procedures to take advantage of recent engineering and algorithmic advances.

CVC4 is intended to be an open and extensible SMT engine, and it can be used as a stand-alone tool or as a library, with essentially no limit on its use for research or commercial purposes.
Comment 1 Jerry James 2013-11-11 18:51:35 EST
Please note that this package currently builds only on F-20 or later.  To make it build on F-19 or earlier, comment out the %patch1 invocation in %prep.
Comment 2 José Matos 2013-12-02 12:44:53 EST
Why do not you place the patch call inside a conditional block:


%if 0%{?fedora} >= 20

%patch1

%endif

this procedure is described here:
http://fedoraproject.org/wiki/Packaging:DistTag
Comment 3 Jerry James 2013-12-11 13:04:05 EST
I could do that, but I am currently not planning to build cvc4 for anything earlier than F-20 anyway, and if I do, then I prefer to modify the spec file for the earlier git branches, rather than use conditionals.

In the meantime, cvc4 version 1.3 has been released.  I have updated the package for that release.  After conferring with upstream, instead of using a patch, Fedora's glpk package is dealt with by passing additional CPPFLAGS to configure.  If a reviewer wishes to build the package for F-19 or earlier, (s)he should remove "-DFEDORA_GLPK_ITCNT" and "-Dlpx_get_int_parm(x,y)=glp_get_it_cnt(x)" from CPPFLAGS.

Spec URL: http://jjames.fedorapeople.org/cvc4/cvc4.spec
SRPM URL: http://jjames.fedorapeople.org/cvc4/cvc4-1.3-1.fc21.src.rpm
Comment 4 Michel Alexandre Salim 2014-01-23 10:20:58 EST
Taking this review
Comment 5 Michel Alexandre Salim 2014-01-27 10:16:20 EST
The main portion of the package looks fine (modulo testing of functionality beyond the test suite, as I'm not versed in CVC4)

The Java bindings, however, does not follow the JNI guidelines:
http://fedoraproject.org/wiki/Packaging:Java#Packaging_JAR_files_that_use_JNI

Multilib is basically not supported for JNI subpackages, and so the SO files should be placed in %{_jnidir} (%{_prefix}/lib/java).

The package is also flagged for not having -javadoc, but as the Java source files do not have headers that could be extracted for this, I think we can omit that.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Packages have proper BuildRequires/Requires on jpackage-utils
- Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- Javadoc documentation files are generated and included in -javadoc
  subpackage
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- This seems like a Java package, please install fedora-review-plugin-java to
  get additional checks


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     NOTE: see the Java section below for an issue with JNI .sos
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "MIT/X11 (BSD like)", "BSL (v1.0)", "GPL (v2 or later)", "Unknown or
     generated", "BSD (3 clause)". 723 files have unknown license. Detailed
     output of licensecheck in /home/michel/sources/fedora/to-
     review/1029227-cvc4/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 6 files.
[!]: Package complies to the Packaging Guidelines
     see Java section
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build

Maven:
[-]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

===== SHOULD items =====

Generic:
[x]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in cvc4-devel
     , cvc4-doc , cvc4-libs , cvc4-java
[?]: Package functions as described.
     Test suite passes, but I have not tested the program itself
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[-]: Packages are noarch unless they use JNI
     Note: cvc4 subpackage is not noarch. Please verify manually
[x]: Package uses upstream build method (ant/maven/etc.)
[!]: JNI guidelines
     http://fedoraproject.org/wiki/Packaging:Java#Packaging_JAR_files_that_use_JNI
     Use %{_jnidir} instead of %{_libdir}/java -- multilib is not supported
     for Java and %{_prefix}/lib64/java is going away per the guidelines

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cvc4-1.3-1.fc20.x86_64.rpm
          cvc4-devel-1.3-1.fc20.x86_64.rpm
          cvc4-doc-1.3-1.fc20.noarch.rpm
          cvc4-libs-1.3-1.fc20.x86_64.rpm
          cvc4-java-1.3-1.fc20.x86_64.rpm
          cvc4-1.3-1.fc20.src.rpm
cvc4.x86_64: W: spelling-error Summary(en_US) prover -> prove, rover, proverb
cvc4.x86_64: W: spelling-error %description -l en_US prover -> prove, rover, proverb
cvc4.x86_64: W: spelling-error %description -l en_US satisfiability -> insatiability, advisability
cvc4.x86_64: W: spelling-error %description -l en_US dually -> dully, dally, dual
cvc4-libs.x86_64: W: spelling-error Summary(en_US) prover -> prove, rover, proverb
cvc4-libs.x86_64: W: spelling-error %description -l en_US prover -> prove, rover, proverb
cvc4-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libcvc4.so.2.0.0 exit@GLIBC_2.2.5
cvc4-java.x86_64: W: no-documentation
cvc4-java.x86_64: W: devel-file-in-non-devel-package /usr/lib64/cvc4/libcvc4jni.so
cvc4.src: W: spelling-error Summary(en_US) prover -> prove, rover, proverb
cvc4.src: W: spelling-error %description -l en_US prover -> prove, rover, proverb
cvc4.src: W: spelling-error %description -l en_US satisfiability -> insatiability, advisability
cvc4.src: W: spelling-error %description -l en_US dually -> dully, dally, dual
cvc4.src: W: patch-not-applied Patch0: %{name}-doxygen.patch
6 packages and 0 specfiles checked; 0 errors, 14 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint cvc4-java cvc4 cvc4-devel cvc4-libs cvc4-doc
cvc4-java.x86_64: W: no-documentation
cvc4-java.x86_64: W: devel-file-in-non-devel-package /usr/lib64/cvc4/libcvc4jni.so
cvc4.x86_64: W: spelling-error Summary(en_US) prover -> prove, rover, proverb
cvc4.x86_64: W: spelling-error %description -l en_US prover -> prove, rover, proverb
cvc4.x86_64: W: spelling-error %description -l en_US satisfiability -> insatiability, advisability
cvc4.x86_64: W: spelling-error %description -l en_US dually -> dully, dally, dual
cvc4-libs.x86_64: W: spelling-error Summary(en_US) prover -> prove, rover, proverb
cvc4-libs.x86_64: W: spelling-error %description -l en_US prover -> prove, rover, proverb
cvc4-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libcvc4.so.2.0.0 exit@GLIBC_2.2.5
5 packages and 0 specfiles checked; 0 errors, 9 warnings.
# echo 'rpmlint-done:'



Requires
--------
cvc4-java (rpmlib, GLIBC filtered):
    cvc4-libs(x86-64)
    java-headless
    jpackage-utils
    ld-linux-x86-64.so.2()(64bit)
    libc.so.6()(64bit)
    libcvc4.so.2()(64bit)
    libcvc4jni.so.2()(64bit)
    libcvc4parser.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgmp.so.10()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libtcmalloc.so.4()(64bit)
    rtld(GNU_HASH)

cvc4 (rpmlib, GLIBC filtered):
    cvc4-libs(x86-64)
    lfsc
    libboost_system.so.1.54.0()(64bit)
    libboost_thread.so.1.54.0()(64bit)
    libc.so.6()(64bit)
    libcvc4.so.2()(64bit)
    libcvc4parser.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgmp.so.10()(64bit)
    libgmpxx.so.4()(64bit)
    libm.so.6()(64bit)
    libprofiler.so.0()(64bit)
    libpthread.so.0()(64bit)
    libreadline.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libtcmalloc.so.4()(64bit)
    rtld(GNU_HASH)

cvc4-devel (rpmlib, GLIBC filtered):
    cvc4-libs(x86-64)
    libcvc4.so.2()(64bit)
    libcvc4parser.so.2()(64bit)

cvc4-libs (rpmlib, GLIBC filtered):
    /usr/sbin/ldconfig
    ld-linux-x86-64.so.2()(64bit)
    libantlr3c.so()(64bit)
    libc.so.6()(64bit)
    libcvc4.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libglpk.so.36()(64bit)
    libgmp.so.10()(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libtcmalloc.so.4()(64bit)
    rtld(GNU_HASH)

cvc4-doc (rpmlib, GLIBC filtered):



Provides
--------
cvc4-java:
    cvc4-java
    cvc4-java(x86-64)
    libcvc4jni.so.2()(64bit)

cvc4:
    cvc4
    cvc4(x86-64)

cvc4-devel:
    cvc4-devel
    cvc4-devel(x86-64)

cvc4-libs:
    cvc4-libs
    cvc4-libs(x86-64)
    libcvc4.so.2()(64bit)
    libcvc4parser.so.2()(64bit)

cvc4-doc:
    cvc4-doc



Unversioned so-files
--------------------
cvc4-java: /usr/lib64/cvc4/libcvc4jni.so

Source checksums
----------------
http://cvc4.cs.nyu.edu/builds/src/cvc4-1.3.tar.gz :
  CHECKSUM(SHA256) this package     : 8013300450130d10e51c8167fcd52eb253404e49524931506e51e1d503d6e3f9
  CHECKSUM(SHA256) upstream package : 8013300450130d10e51c8167fcd52eb253404e49524931506e51e1d503d6e3f9


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1029227
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, Java, C/C++
Disabled plugins: Python, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 6 Jerry James 2014-01-27 17:10:32 EST
(In reply to Michel Alexandre Salim from comment #5)
> The Java bindings, however, does not follow the JNI guidelines:
> http://fedoraproject.org/wiki/Packaging:Java#Packaging_JAR_files_that_use_JNI
> 
> Multilib is basically not supported for JNI subpackages, and so the SO files
> should be placed in %{_jnidir} (%{_prefix}/lib/java).

Fixed.

> The package is also flagged for not having -javadoc, but as the Java source
> files do not have headers that could be extracted for this, I think we can
> omit that.

Right, there are no actual Java sources, just JNI objects.

New URLs:
Spec URL: http://jjames.fedorapeople.org/cvc4/cvc4.spec
SRPM URL: http://jjames.fedorapeople.org/cvc4/cvc4-1.3-2.fc21.src.rpm
Comment 7 Jerry James 2014-01-31 11:10:26 EST
Ping.
Comment 8 Michel Alexandre Salim 2014-01-31 23:52:57 EST
Changes look fine, APPROVED
Comment 9 Jerry James 2014-02-01 14:14:09 EST
Thank you for the review, Michel.

New Package SCM Request
=======================
Package Name: cvc4
Short Description: Automatic theorem prover for SMT problems
Owners: jjames
Branches: f20
InitialCC:
Comment 10 Gwyn Ciesla 2014-02-03 07:48:39 EST
Git done (by process-git-requests).
Comment 11 Fedora Update System 2014-02-03 15:07:01 EST
cvc4-1.3-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/cvc4-1.3-2.fc20
Comment 12 Fedora Update System 2014-02-04 22:35:26 EST
cvc4-1.3-3.fc20 has been pushed to the Fedora 20 testing repository.
Comment 13 Fedora Update System 2014-02-14 03:01:16 EST
cvc4-1.3-3.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.